function initCombi()
    EasyMode = true

    Combi = {}

    Combi.items = {
        "Blood Candle",
        "Blood",
        "Satanic Bible",
        "Bones",
        "Drinking Horn",
        "Pot Flower",
        "Pocket Watch",
        "Dog Food",
        "Steak",
        "Beer Bottle",
        "Stick",
        "Book",
        "Puppy",
        "Viking Helmet",
        "Knife",
        "Can of Soup",
        "Tomato",
        "Balloon",
        "Winebottle",
        "Hammer",
        "Battery",
        "Satellite",
        "Money",
        "Candle",
        "Energydrink",
        "Rocket"
    }

    Combi.pairs = {
        {{"Steak","Puppy"},"Bones"},
        {{"Viking Helmet","Hammer"},"Drinking Horn"},
        {{"Puppy","Knife"},"Blood"},
        {{"Candle","Blood"},"Blood Candle"},
        {{"Book","Satellite"},"Satanic Bible"},
        {{"Pot Flower","Pocket Watch"},"Stick"},
        {{"Stick","Pocket Watch"},"Book"},
        {{"Dog Food","Stick"},"Puppy"},
        {{"Beer Bottle","Bones"},"Viking Helmet"},
        {{"Viking Helmet","Steak"},"Knife"},
        {{"Dog Food","Blood"},"Can of Soup"},
        {{"Can of Soup","Pot Flower"},"Tomato"},
        {{"Bones","Pot Flower"},"Balloon"},
        {{"Balloon","Pocket Watch"},"Winebottle"},
        {{"Winebottle","Stick"},"Hammer"},
        {{"Dog Food","Puppy"},"Battery"},
        {{"Balloon","Battery"},"Satellite"},
        {{"Puppy","Satellite"},"Money"},
        {{"Stick","Money"},"Candle"},
        {{"Battery","Beer Bottle"},"Energydrink"},
        {{"Energydrink","Satellite"},"Rocket"},
        }

    Combi.finalPairs = {
        {{"Blood Candle", "Drinking Horn", "Bones", "Blood", "Satanic Bible"}, "Satan"},
        {{"Puppy","Pot Flower","Balloon","Drinking Horn","Tomato"},"Goat"},
        {{"Rocket","Tomato","Battery","Balloon","Candle"},"Santa"},
    }

    Combi.initialItems = {
        "Pot Flower",
        "Pocket Watch",
        "Dog Food",
        "Steak",
        "Beer Bottle",
        "Viking Helmet",
    }


    checkCombi()
    resetCombi()
end

function checkCombi()
    -- for _,elem in ipairs(Combi.items) do
    --     Combi.items[elem] = true
    -- end

    -- for _,pair in ipairs(Combi.finalPairs) do
    --     for _,elem in ipairs(pair[1]) do
    --         if not Combi.items[elem] then print(elem) end
    --     end
    --     -- print(Combi.items[pair[2]])
    --     local elem = pair[2]
    --         if not Combi.items[elem] then print(elem) end
    -- end


end

function resetCombi()
    -- random sort
    Combi.missingPairs = randomizedListCopy(Combi.pairs)
    Combi.donePairs = {}


    Combi.availableItems = cloneListRecur(Combi.initialItems)


    -- if EasyMode then
        recalcShines()
    -- else
    --     Combi.shines = {}
    --     for _,pair in ipairs(Combi.pairs) do
    --         for _,elem in ipairs(pair[1]) do
    --             if not Combi.shines[elem] then
    --                 Combi.shines[elem] = 1
    --             else
    --                 Combi.shines[elem] = Combi.shines[elem] + 1
    --             end
    --         end
    --     end
    -- end
end

function checkShine(elemName)
    return Combi.shines[elemName]
end

function markShine(elemName)
    -- if not EasyMode then
    --     if Combi.shines[elemName] and Combi.shines[elemName] > 0 then
    --         Combi.shines[elemName] = Combi.shines[elemName] - 1
    --         if Combi.shines[elemName] == 0 then
    --             Combi.shines[elemName] = nil
    --         end
    --     end
    -- end
end

function recalcShines()
    -- if EasyMode then
        Combi.shines = {}


        local itemMap = {}
        for _,itemName in ipairs(Combi.availableItems) do
            itemMap[itemName] = true
        end


        for _,group in ipairs({Combi.missingPairs, Combi.finalPairs}) do
        -- for _,group in ipairs({Combi.missingPairs}) do
            for _,pair in ipairs(group) do
                local possible = true
                for _,ingredient in ipairs(pair[1]) do
                    if not itemMap[ingredient] then
                        possible = false
                        break
                    end
                end

                if possible then
                    for _,ingredient in ipairs(pair[1]) do
                        local ms = Combi.shines[ingredient] or 2
                        local Ms = (group == Combi.missingPairs and 1 or 2)
                        Combi.shines[ingredient] = math.min(ms, Ms)
                    end
                end
            end
        end
    -- end
end

function cloneListRecur(tabl)
    local res = {}
    for _,elem in ipairs(tabl) do
        if type(elem) == "table" then
            table.insert(res, cloneListRecur(elem))
        else
            table.insert(res, elem)
        end
    end
    return res
end

function getCombiResult(itemList)
    -- for _,group in ipairs({Combi.missingPairs, Combi.donePairs, Combi.finalPairs}) do
    -- for _,group in ipairs({Combi.missingPairs}) do
    for _,group in ipairs({Combi.missingPairs, Combi.finalPairs}) do
        for _,pair in ipairs(group) do
            local itemMap = {}
            for _,item in ipairs(itemList) do
                itemMap[item] = true
            end

            local matches = 0
            for _,refItem in ipairs(pair[1]) do
                if itemMap[refItem] then
                    matches = matches + 1
                end
            end

            if matches == #pair[1] then
                return pair
            end
        end
    end
end

function consumeCombi(refPair)
    local isNew = false
    for i,pair in ipairs(Combi.missingPairs) do
        if pair == refPair then
            table.remove(Combi.missingPairs, i)
            table.insert(Combi.donePairs, refPair)
            table.insert(Combi.availableItems, pair[2])
            isNew = true
            break
        end
    end

    -- randomize output each time to prevent boring repetition
    Combi.donePairs = randomizedListCopy(Combi.donePairs)

    return isNew
end

function randomizedListCopy(list)
    local res = {}
    local cp = cloneListRecur(list)
    while #cp>0 do
        table.insert(res, table.remove(cp, math.random(#cp)))
    end
    return res
end

function getNearMiss(nameList)
    local results = {}
    for _,pair in ipairs(Combi.finalPairs) do
        -- prepare map of matches
        local matches = {}
        for _,name in ipairs(nameList) do
            matches[name] = true
        end

        local res = {}
        -- mark the matches
        for _,dest in ipairs(pair[1]) do
            if matches[dest] then
                table.insert(res,dest)
            end
        end

        if #res > 0 then
            table.insert(results, res)
        end
    end

    if #results == 0 then return nil end
    table.sort(results, function(a,b) return #a > #b end)
    return results[1]
end
