function initIntro()
    Intro = {}
    Intro.active = true
    Intro.timer = 0
    Intro.delay = 5
    Intro.opacity = 1

    -- Intro.autoOut = not INTERNAL
    Intro.autoOut = false
end

function resetIntro()
    -- intro not repeated
end

function updateIntro(dt)
    if not Intro.active then
        return
    end

    if Intro.autoOut then
        Intro.timer = Intro.timer + dt
    end

    if Intro.timer > Intro.delay then
        Intro.opacity = decreaseExponential(dt, Intro.opacity, 0.97)
        if Intro.opacity <= 0 then
            Intro.active = false
        end
    end
end

function drawIntro()
    if not Intro.active then
        return
    end

    love.graphics.setColor(0,0,0, 255 * Intro.opacity)
    love.graphics.rectangle("fill", 0, 0, screenSize.x, screenSize.y)

    love.graphics.setColor(255,0,0)
    printCentered("SSS", headerFont, 250)
    printCentered("Satanic Summoning Simulator", font, 500)
end

function introClicked()
    Intro.timer = Intro.delay+1
end

function printCentered(txt, fnt, y)
    local fnt = fnt or font
    local w = fnt:getWidth(txt)
    love.graphics.setFont(fnt)
    love.graphics.print(txt, (screenSize.x - w)*0.5, y)
end